# Copyright Sergej Kurakin 2006
# http://kurakin.info/
# sergej@kurakin.info
#
# THIS SOFTWARE IS PROVIDED BY SERGEJ KURAKIN ``AS IS'' AND ANY EXPRESS
# OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
# NON-INFRINGEMENT, ARE DISCLAIMED.  IN NO EVENT SHALL SERGEJ KURAKIN
# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.


# Usage:
# exportrevs.rb --from (revision from) --to (revision to)
# exportrevs.rb --from 400 -to 500
#
# exportrevs.rb -f (revision from) -t (revision to)
# exportrevs.rb -f 400 -t 500


#path to subversion library
SUBVERSION_PATH = 'C:\\Progra~1\\Subver~1\\bin\\'
#path tu repository
REPOSIRY_PATH = 'E:\\path\\to\\repository\\root\\'
#path to patch place
UNPACK_PATH = 'E:\\path\\to\\place\\changed\\files\\'
# separator on your file system, set manualy (i used windows for development, and don't tested it on unix, but i think, it shoud be cross-platform)
SYSTEM_PATH_SEPARATOR = "\\"

require 'getoptlong'

opts = GetoptLong.new(
  [ "--from",    "-f",            GetoptLong::REQUIRED_ARGUMENT ],
  [ "--to",    "-t",            GetoptLong::REQUIRED_ARGUMENT ]
)

opts.each do |opt, arg|
  if opt == "--from" or opt == "-f" then
  	puts "from"
  	@from = arg.inspect 
  end
  if opt == "--to" or opt == "-t" then
  	puts "from"
  	@to = arg.inspect
  end
end

if (@from and @to) then

	@files = []
	print "Collecting changes files\n"
	for revid in @from..@to do
		changes = `#{SUBVERSION_PATH}svnlook changed -r #{revid} #{REPOSIRY_PATH}`.split("\n")
		for change in changes do
			data = change.split
			if (data and data.length ==2 and data[0] == 'A' or data[0] == 'U') then
				@files.push(data[1])
			end
		end
	end

	print "Generating files, to bee updated\n"

	@files = @files.uniq

	print "Extracting updated files\n"

	for file in @files do
		realfile = file.split('/')
		realfile.shift
		dirs = realfile.clone
		if file[-1,1] != '/' then
			dirs.pop
		end
		if !dirs.empty? then
			dirpath = []
			for dir in dirs do
				dirpath.push(dir)
				if !File.directory?(UNPACK_PATH+dirpath.join(SYSTEM_PATH_SEPARATOR)) then
					Dir.mkdir(UNPACK_PATH+dirpath.join(SYSTEM_PATH_SEPARATOR))
				end
			end
		end
		if file[-1,1] != '/' then
			realfile = realfile.join(SYSTEM_PATH_SEPARATOR)
			`#{SUBVERSION_PATH}svnlook cat #{REPOSIRY_PATH} #{file} > #{UNPACK_PATH}#{realfile}`
		end
	end

	print "Done\n";
end
